/**********************************************************************
   Copyright (C) Christopher Yeoh <cyeoh@samba.org> 2005
   
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
**********************************************************************/
#include "PlayerGestures.H"

PlayerGestures::PlayerGestures(QWidget *Parent)
    : QHBoxLayout(Parent)
{
    leftGestures = new QListBox(Parent);
    rightGestures = new QListBox(Parent);

    addWidget(leftGestures);
    addWidget(rightGestures);

    leftGestures->show();
    rightGestures->show();
}

void
PlayerGestures::AddGestures(Gesture Left, Gesture Right) 
{
    leftGestures->insertItem(Spells::getGestureName(Left));
    rightGestures->insertItem(Spells::getGestureName(Right));
}

void
PlayerGestures::Show()
{
}

void
PlayerGestures::Hide()
{
    leftGestures->hide();
    rightGestures->hide();
}
